require 'thread'

class List

class Item
  @field_name = []
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end

  @field_size = []
  def self.field_size
    @field_size
  end
  @size = 1+16
  def self.size
    @size
  end
  def self.field_size=(list)
    @field_size = list
    @size = @field_size.inject(1+16){|i,x| i+=x+1 }+1
  end
  self.field_size = [16]

  attr_reader :key
  def Item.new_key
    require 'digest/md5'
    md5 = Digest::MD5::new
    md5.update(String(Time::now))
    md5.update(String(rand(0)))
    md5.update(String($$))
    md5.update('foobar')
    md5.hexdigest[0,16]
  end
  def initialize(key, *fields)
    @key = key || raise
    @fields = fields
  end
  def Item.field_name_line
    ret = "#"
    ret.concat "key".ljust(16)
    field_size.each_with_index{|size, idx|
      field = String(field_name[idx])
      field = field[0,size]
      field = field.ljust(size) + "#" # terminater
      ret.concat field
    }
    ret.concat "\n"
    ret
  end
  def self.new_from_line(str)
    mark = str[0,1]
    return nil if mark == "#" # deleted
    key = str[1,16]
    fields = []
    @field_size.inject(1+16) do |offset, size|
      fields.push str[offset, size+1].sub(/#.*$/,'') # trim
      offset += size+1
    end
    self.new(key, *fields)
  end
  def to_line
    ret = " "
    ret.concat @key
    self.class.field_size.each_with_index{|size, idx|
      field = String(@fields[idx])
      field = field[0,size] + "#" # terminater
      field = field.ljust(size+1)
      ret.concat field
    }
    ret.concat "\n"
    ret
  end
  def field_by_name(name)
    @fields[self.class.field_name.index(name)]
  end
  def to_hash
    hash = { :key => @key }
    @fields.each_with_index do |field, idx|
      hash[self.class.field_name[idx]] = field
    end
    hash
  end
  def edit(*fields)
    [@fields.size, fields.size].max.times do |idx|
     @fields[idx] = fields[idx] if fields[idx]
    end
  end
end

  @dbname = 'list.db'
  def self.dbname
    @dbname
  end
  def self.dbname=(dbname)
    @dbname = dbname
  end

  @item_class = Item
  def self.item_class
    @item_class
  end
  def self.item_class=(item_class)
    @item_class = item_class
  end

  def initialize
    @item = []
    @mutex = Mutex.new
    @offset = {}
    load
  end

  def add(*fields)
    while @offset.key?(key = self.class.item_class.new_key) do end
    item = self.class.item_class.new(key, *fields)
    @item.push item
    save item
    item
  end

  def edit(key, *fields)
    item = find(key)
    item.edit(*fields)
    save item
    item
  end

  def remove(key)
    item = find(key)
    if item
      @item.delete item
      delete item
    end
    item
  end

  def find(key)
    @item.find{|item| item.key == key }
  end
  private :find

  def fetch_hash_all
    if block_given?
      @item.each do |item|
        yield item.to_hash
      end
    else
      @item.collect{|item| item.to_hash }
    end
  end

  def fetch_hash(key)
    item = find(key)
    return nil unless item
    item.to_hash
  end

private
  def load
    item_size = self.class.item_class.size
    @mutex.synchronize do
    begin
      begin
        f = File.open(self.class.dbname, "rb+")
      rescue Errno::ENOENT
        f = File.open(self.class.dbname, "wb+")
        name_line = self.class.item_class.field_name_line
        f.print name_line
        break
      end
      while line = f.read(item_size)
        item = self.class.item_class.new_from_line(line)
        offset = f.tell - item_size
        raise "odd offset #{offset} #{f.path}" unless offset % item_size == 0
        next  unless item # this item is deleted
        @offset[item.key] = offset
        @item.push item
      end
    ensure
      f.close
    end
    p [:load, self.class.dbname, @offset] if $DEBUG
    end
  end
  def save(item)
    item_size = self.class.item_class.size
    @mutex.synchronize do
      File.open(self.class.dbname, "rb+") do |f|
        idx = @offset[item.key]
        if idx
          f.seek(idx)
        else
          f.seek(0, IO::SEEK_END)
        end
        offset = f.tell
        raise "odd offset #{offset} #{f.path}" unless offset % item_size == 0
        @offset[item.key] = offset
        f.print item.to_line
      end
    end
    p [:save, self.class.dbname, @offset] if $DEBUG
  end
  def delete(item)
    @mutex.synchronize do
      File.open(self.class.dbname, "rb+") do |f|
        idx = @offset[item.key]
        break unless idx
        f.seek(idx)
        f.print '#' # deleted
      end
    end
    p [:delete, self.class.dbname, @offset] if $DEBUG
  end
end

if $0 == __FILE__
  List::Item.field_name = [:name, :long_field_name]
  List::Item.field_size = [6, 3]
p List::Item.size
  list = List.new
# item = List::Item.new
  item = list.add('moriq')
  item = list.add( 'm' * List::Item.field_size[0] )
  item = list.add('Kazuhiro Yoshida')
# item
  list.remove(item.key)
end
