require 'list'
require 'forwardable'
class ListProducer < Web::Producer
  set_erb('list.erb')
  @field_name = List::Item.field_name
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end
  @field_caption = {}
  def self.field_caption
    @field_caption
  end
  def self.field_caption=(caption)
    @field_caption = caption
  end
  @caption = 'List'
  def self.caption
    @caption
  end
  def self.caption=(caption)
    @caption = caption
  end
  def initialize(session, list)
    super(session)
    @list = list
    @mode = :browse
    @selector = []
def @selector.store(name, value)
    pair = self.assoc(name)
    if pair then pair[1] = value else self.push [name, value] end
    value
end
    @sort_field_name = nil
    @sort_reverse = false
  end
  def sort(name)
    if @sort_field_name == name
      @sort_reverse = ! @sort_reverse
    else
      @sort_field_name = name
      @sort_reverse = false
    end
  end
  def do_sort(context, params)
    name, = params['name']
    name = name.intern
    sort(name)
  end
  def do_rm_selector(context, params)
    name, = params['name']
    name = name.intern
    assoc = @selector.assoc(name)
    @selector.delete(assoc) if assoc
  end
  def do_clear_selector(context, params)
    @selector.clear
  end
  def do_select(context, params)
    name, = params['name']
    value, = params['value']
    name = name.intern
    @selector.store(name, value)
  end
  extend Forwardable
  def_delegators(:@list,
    :add, :edit, :remove, :find,
    :fetch_hash, :fetch_hash_all)
  def do_add(context, params)
      fields = self.class.field_name.map{|name| params[name.to_s][0] }
      add(*fields)
  end
  def do_edit(context, params)
    case @mode
    when :browse
      key, = params['key']
      @currkey = key
      @mode = :edit
    when :edit
      key, = params['key']
      fields = self.class.field_name.map{|name| params[name.to_s][0] }
      edit(key, *fields)
      @mode = :browse
    end
  end
  def do_remove(context, params)
      key, = params['key']
      remove(key)
  end
  def browse
      @mode = :browse
  end
  def hide
      @mode = :hide
  end
  def do_browse(context, params)
      browse
  end
  def do_hide(context, params)
      hide
  end

def field_caption(name)
	self.class.field_caption[name]
end
def field_name_count
	self.class.field_name.size
end
def get_field_name
	self.class.field_name
end
def field_name_each
	self.class.field_name.each do |name|
		yield name
	end
end
def field_name_caption_each
	self.class.field_name.each do |name|
		yield name, self.class.field_caption[name]
	end
end
def field_name_value_each(item)
	self.class.field_name.each do |name|
		yield name, item[name]
	end
end
def field_name_list
	ret = []
	field_name_each do |name|
		next if @selector.assoc(name)
		ret.push name
	end
	ret
end
def field_caption_list
	ret = []
	field_name_caption_each do |name, caption|
		next if @selector.assoc(name)
		ret.push caption
	end
	ret
end
def field_data_list(sort_field_name=nil, sort_reverse=nil)
	ret = []
	@list.fetch_hash_all do |item|
		found = false
		field_name_value_each(item) do |name, value|
			pair = @selector.assoc(name)
			if pair && pair[1] != value
				found = true
				break
			end
		end
		next if found
		tmp = []
		field_name_value_each(item) do |name, value|
			next if @selector.assoc(name)
			tmp.push value || ''
		end
		tmp.push item
		ret.push tmp
	end
	if sort_field_name
		field_name = field_name_list
		sort_num = field_name.index(sort_field_name)
		if sort_num then
			if sort_reverse then
				ret.sort{|x,y| y[sort_num]<=>x[sort_num]}
			else
				ret.sort{|x,y| x[sort_num]<=>y[sort_num]}
			end
		else
			ret.sort
		end
	else
		ret.sort
	end
end

end

